config/routes.rb
Rails.application.routes.draw do
  devise_for :users
  root "search#index"

  resources :articles do
    resources :comments
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ApplicationRecord
	include Visible
  
	has_many :comments, dependent: :destroy
  
	validates :title, presence: true
	validates :body, presence: true, length: { minimum: 10 }
  end
  

app/models/comment.rb
class Comment < ApplicationRecord
  include Visible
  belongs_to :article
end

app/models/concerns/visible.rb
module Visible
	extend ActiveSupport::Concern
  
	VALID_STATUSES = ['public', 'private', 'archived']
  
	included do
	  validates :status, inclusion: { in: VALID_STATUSES }
	end
  
	class_methods do
	  def public_count
		where(status: 'public').count
	  end
	end
  
	def archived?
	  status == 'archived'
	end
  end
  

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController  

  def index
    @q = Article.ransack(params[:q])
		@articles = @q.result
  end

  def show
    @article = Article.find(params[:id])
  end

  def new
    @article = Article.new
  end

  def create
    @article = Article.new(article_params)

    if @article.save
      redirect_to @article
    else
      render :new
    end
  end

  def edit
    @article = Article.find(params[:id])
  end

  def update
    @article = Article.find(params[:id])

    if @article.update(article_params)
      redirect_to @article
    else
      render :edit
    end
  end

  def destroy
    @article = Article.find(params[:id])
    @article.destroy

    redirect_to root_path
  end

  private
    def article_params
      params.require(:article).permit(:title, :body, :status)
    end
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
	def create
	  @article = Article.find(params[:article_id])
	  @comment = @article.comments.create(comment_params)
	  redirect_to article_path(@article)
	end
  
	def destroy
	  @article = Article.find(params[:article_id])
	  @comment = @article.comments.find(params[:id])
	  @comment.destroy
	  redirect_to article_path(@article)
	end
  
	private
	  def comment_params
		params.require(:comment).permit(:commenter, :body, :status)
	  end
  end
  

app/controllers/search_controller.rb
class SearchController < ApplicationController
	def index
		@q = Article.ransack(params[:q])
		@articles = Kaminari.paginate_array(@q.result).page(params[:page]).per(3)
	end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/articles_helper.rb
module ArticlesHelper
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/helpers/search_helper.rb
module SearchHelper
end

app/views/articles/_form.html.erb
<%= simple_form_for @article, defaults: { input_html: { class: 'd-block' } } do |f| %>
  <%= f.input :title, required: false %>
  <%= f.input :body, required: false %>
  <%= f.select :status, ['public', 'private', 'archived'], selected: 'public' %>
  <%= f.submit :submit %>
<% end %>

app/views/articles/edit.html.erb
<h1>Edit Article</h1>

<% if user_signed_in? %>
	<%= render "form", article: @article %>
<% end %>

app/views/articles/index.html.haml
%h1 Articles

Our blog has
%span= Article.public_count 
articles and counting!

%ul
  - @articles.each do |article|
    %li
      = link_to article.title, article

= link_to "New Article", new_article_path

app/views/articles/new.html.erb
<h1>New Article</h1>

<% if user_signed_in? %>
	<%= render "form", article: @article %>
<% end %>

app/views/articles/show.html.erb
<h1><%= @article.title %></h1>

<p><%= @article.body %></p>

<% if user_signed_in? %>
  <ul>
    <li><%= link_to "Edit", edit_article_path(@article) %></li>
    <li><%= link_to "Destroy", article_path(@article),
      method: :delete,
      data: { confirm: "Are you sure?" } %></li>
  </ul>
<% end %>

<h2>Comments</h2>
<%= render @article.comments %>

<% if user_signed_in? %>
  <h2>Add a comment:</h2>
  <%= render 'comments/form' %>
<% end %>

app/views/comments/_comment.html.erb
<p>
  <strong>Commenter:</strong>
  <%= comment.commenter %>
</p>

<p>
  <strong>Comment:</strong>
  <%= comment.body %>
</p>

<% if user_signed_in? %>
  <p>
    <%= link_to 'Destroy Comment', [comment.article, comment],
      method: :delete,
      data: { confirm: "Are you sure?" } %>
  </p>
<% end %>

app/views/comments/_form.html.erb
<%= form_with model: [ @article, @article.comments.build ] do |form| %>
	<p>
	  <%= form.label :commenter %><br>
	  <%= form.text_field :commenter %>
	</p>
	<p>
	  <%= form.label :body %><br>
	  <%= form.text_area :body %>
	</p>
	<p>
	  <%= form.submit %>
	</p>
	<p>
		<%= form.label :status %><br>
		<%= form.select :status, ['public', 'private', 'archived'], selected: 'public' %>
	</p>
  <% end %>
  

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blog</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
  </head>

  <body>
    <p class="notice"><%= notice %></p>
    <p class="alert"><%= alert %></p>

    <% if user_signed_in? %>
      <%= link_to "Sign out", destroy_user_session_path, method: :delete %>      
    <% else %>
      <a href="/users/sign_in">Sign in</a>
    <% end %>

    <%= yield %>    
  </body>
</html>

app/views/search/index.html.erb
<div class="container mt-4">

  <h1>Articles</h1>

  <%= search_form_for @q do |f| %>
    <%= f.label :title_cont %>
    <%= f.search_field :title_cont %>
    <%= f.submit %>
  <% end %>

  <div class="mt-4"> 
    Our blog has <%= Article.public_count %> articles and counting!
  </div>

  <div class="my-4"> 
    <%= paginate @articles %>
  </div>

  <ul>
    <% @articles.each do |article| %>
      <li>
        <%= link_to article.title, article %>
      </li>
    <% end %>
  </ul>

  <% if user_signed_in? %>
    <%= link_to "New Article", new_article_path %>
  <% end %>  

</div>

<style>
  .page, .first, .prev, .next { margin: 0 .5rem 0 0 }
</style>